namespace  QPG.Demo {
	using System;
	using System.Collections;
	using NUnit.Framework;
	using QPG;
	using QPG.Interface;
using QPG.Utility;


	using  QPG.Demo.Components;

	[TestFixture]
	public class LisfCycleTester {
		private SimpleContainer container;
	
		[SetUp]
		public void Init() {
			Hashtable ht=new Hashtable();
			//ht.Add("qpg.email_sender",typeof(EmailSender));
			container = new SimpleContainer(ht);
		}
		[TearDown]
		public void Finish() {
			container.Dispose();
		}

		private void visitProduct(string key,int num) {

			Product p;
			ArrayList  ps=new ArrayList();

			int i;
			for( i=0;i<num;i++) {
				p=container[key] as Product;
				Console.WriteLine("{0}--{1}",i+1,p.Price);
				p.setPrice((i+1)*10);
				ps.Add(p);
			}
			for(i=0;i<ps.Count;i++) {
				container.Release(ps[i]);
			}
			ps.Clear();
		}

		private void visitPooledProduct(string key,int num) {

			Product p;
			int i;
			for( i=0;i<num;i++) {
				p=container[key] as Product;
				Console.WriteLine("{0}--{1}",i+1,p.Price);
				p.setPrice((i+1)*10);
				container.Release(p);
			}
			
		}
		private void runTest(string key) {
			
			long t1=System.Environment.TickCount;
			visitProduct(key,4);
			if(key!="p2") visitProduct(key,10000);
			else visitPooledProduct(key,10000);
			long t2=System.Environment.TickCount-t1;
			Console.WriteLine("{0}ms",t2);
		}

		[Test]
		public void tesSingleton() {
			runTest("p1");
		
		}	
		[Test]
		public void testPool() {
			
			runTest("p2");
		}
		[Test]	
		public void testMany() {
			

			runTest("p3");
		}

		
		
		[Test]
		public void testZip() {
			EncryptionService es=new EncryptionService();
			Zipper z=new Zipper();
			string s1=z.zipString("QPG.test");
			Console.WriteLine("Zip:"+s1);
			string s2=es.Encrypt(s1);
			Console.WriteLine("Encrypt:"+s2);

			string s3=es.Decrypt(s2);
			Console.WriteLine("Decrypt:"+s3);
			string s4=z.unzipString(s3);
			Console.WriteLine("UnZip:"+s4);
			Assert.AreEqual("QPG.test",s4);

		}
		[Test] public void testLog() {
		SimpleContainer.SysLogger.DEBUG("hello world! SO SIMPLE! ");
		}
		
	}
}