// Copyright 2004-2005 Castle Project - http://www.castleproject.org/
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
// 
//     http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

namespace QPG.Demo.Services {
	using System;
	using System.Collections;
	using System.Threading;

	using Castle.Model;
	using QPG.Interface;
	using QPG.Utility;
	using QPG.Demo.Components;
	
	
	
	public class FormulaDynamicCompileService : IService,IStartable {
		private static readonly ILogService log = SimpleContainer.SysLogger;
		private   IMessageQueue _mq ;

		private bool _Started = false;
		private bool _Stopped = false;
		System.Threading.Thread _thread;
		private static FunctionEvaluator fe=new FunctionEvaluator();

		
		private string _serviceName="qpg.calculate_service";
	
		
		public FormulaDynamicCompileService() {
			_mq= SimpleContainer.MessageQueue;
			
		}
		public virtual DTO handle(DTO data) {
			Parameter p1,p2;
			ParametersHelper ph=new ParametersHelper(data.RequestArgs);
			ParametersHelper ph2=new ParametersHelper();
			if(ph.Count<3){
				
				p1=new Parameter("Msg","ȷ");
				ph2.addParameter(p1);
				p2=new Parameter("Result",int.MinValue);
				ph2.addParameter(p2);
				data.setOutputData(ph2.Items,null);
				return data;
			}
			
			fe.Text=ph["F(x,y)"].ToString();
			double rt=fe.Invoke(System.Convert.ToDouble(ph["x"])
				,System.Convert.ToDouble(ph["y"]));
			p1=new Parameter("Msg","OK");
			ph2.addParameter(p1);
			p2=new Parameter("Result",rt);
			ph2.addParameter(p2);
			data.setOutputData(ph2.Items,null);
		
			return data;
		}
		public string ServiceName {
			get{return _serviceName;}
		}

		public virtual void Start() {
			if(_Started==true) return;
			
			_thread=new Thread(new ThreadStart(handle));
			
			_thread.Start();
			//log.INFO("Math Service Started");
			Console.WriteLine("Math Service Started");
			_Started=true;
		}

		public virtual void handle() {
			while(Started) {
			
				DTO d=_mq.receieveRequestFromQueue(ServiceName);
				if(d!=null) {
					d=handle(d);
					_mq.sendResultToQueue(d.TransactionID,d);
					//	log.DEBUG("Handled Calculate Service:"+new ParametersHelper(d.RequestArgs).ToString());
				}
				else Thread.Sleep(3);
			}
				
		}
		public virtual void Stop() {
			
			//log.INFO("Math Service Stopped");
			Console.WriteLine("Math Service Stopped");
			_thread.Join(1000);
			_thread.Abort();
			_Stopped =  true;
		}

		public virtual bool Started {
			get { return _Started; }
		}

		public virtual bool Stopped {
			get {
				
				return _Stopped; }
		}
	}
}
